Blockly.defineBlocksWithJsonArray([
  {
    type: 'element_new_button',
    message0: 'Erstelle neuen Button namens %1 und mache damit… %2',
    args0: [
      {
        type: 'input_value',
        name: 'name',
        check: 'String',
      },
      {
        type: 'input_statement',
        name: 'methods',
        check: ['method-button'],
      },
    ],
    previousStatement: null,
    nextStatement: null,
    colour: '#990000'
  },
  {
    type: 'element_new_area',
    message0: 'Erstelle neue Fläche %1 und mache damit… %2',
    args0: [
      {
        type: 'input_value',
        name: 'name',
        check: 'String',
        align: 'right',
      },
      {
        type: 'input_statement',
        name: 'methods',
        check: ['method-area', 'method-button'],
      },
    ],
    extensions: ['element_new_area_extension'],
    previousStatement: null,
    nextStatement: null,
    colour: '#990000'
  },
  {
    type: 'element_find',
    message0: 'Finde Element(e) namens %1 und mache damit… %2',
    args0: [
      {
        type: 'input_value',
        name: 'name',
        check: 'String',
      },
      {
        type: 'input_statement',
        name: 'methods',
        check: ['method-area', 'method-button'],
      },
    ],
    previousStatement: null,
    nextStatement: null,
    colour: '#990000'
  },
  {
    type: 'element_method_change_property',
    message0: '…ändere %1',
    args0: [
      {
        type: 'input_value',
        name: 'value',
      }
    ],
    previousStatement: 'method-area',
    nextStatement: 'method-area',
    extensions: ['element_method_change_property_extension'],
    colour: '#990000'
  },
  {
    type: 'element_method_move_area',
    message0: '…verschiebe die Fläche %1',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      },
    ],
    previousStatement: 'method-area',
    nextStatement: 'method-area',
    extensions: ['element_method_move_area_extension'],
    colour: '#990000'
  },
  {
    type: 'element_method_delete',
    message0: '…lösche das Element',
    previousStatement: ['method-area', 'method-button',],
    colour: '#990000'
  },
  {
    type: 'element_method_change_text',
    message0: '…ändere den Text auf %1',
    args0: [
      {
        type: 'input_value',
        name: 'text',
        check: 'String',
      },
    ],
    previousStatement: ['method-area', 'method-button',],
    nextStatement: ['method-area', 'method-button',],
    colour: '#990000'
  },
  {
    type: 'element_method_change_image',
    message0: '…ändere das Bild auf %1',
    args0: [
      {
        type: 'input_value',
        name: 'image',
        check: 'Image',
      },
    ],
    previousStatement: ['method-area', 'method-button',],
    nextStatement: ['method-area', 'method-button',],
    colour: '#990000'
  },
  {
    type: 'event_key',
    message0: 'Bei Druck auf %1 mache %2',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      },
      {
        type: 'input_statement',
        name: 'statements'
      },
    ],
    previousStatement: null,
    nextStatement: null,
    extensions: ['event_key_extension'],
    colour: '#00cccc'
  },
  {
    type: 'element_method_event_click',
    message0: '…bei Klick darauf %1 mache damit… %2 und dann mache %3',
    args0: [
      {
        type: 'input_dummy',
      },
      {
        type: 'input_statement',
        name: 'methods',
        align: 'right',
        check: ['method-area', 'method-button'],
      },
      {
        type: 'input_statement',
        name: 'statements',
        align: 'right',
      },
    ],
    previousStatement: ['method-area', 'method-button',],
    nextStatement: ['method-area', 'method-button',],
    colour: '#00cccc'
  },
  {
    type: 'colour_transparent',
    message0: 'transparent',
    output: 'Transparent',
    colour: '#a5745b'
  },
  {
    type: 'image_animal',
    message0: 'Tier %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_plant',
    message0: 'Pflanze %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_face',
    message0: 'Gesicht %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_food',
    message0: 'Lebensmittel %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_sports',
    message0: 'Sport %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_person',
    message0: 'Mensch %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_body',
    message0: 'Körperteile %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_family',
    message0: 'Familie %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_transport',
    message0: 'Verkehr %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_place',
    message0: 'Orte & Gebäude %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_sky',
    message0: 'Himmel %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_time',
    message0: 'Zeit %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_music',
    message0: 'Musik %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_clothing',
    message0: 'Kleidung %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_game',
    message0: 'Spiel %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_writing',
    message0: 'Schreiben %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_computer',
    message0: 'Computer %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_objects',
    message0: 'Gegenstände %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'image_symbol',
    message0: 'Symbole %1',
    output: 'Image',
    args0: [
      {
        type: 'input_dummy',
        name: 'container',
      }
    ],
    extensions: ['image_extension'],
    colour: '#99cc66',
  },
  {
    type: 'element_get_property_as_number',
    message0: 'aktueller Wert (in %) %1 %2 %3 von Element namens %4',
    output: 'Number',
    args0: [
      {
        type: 'input_dummy',
      },
      {
        type: 'field_dropdown',
        name: 'property',
        options: [
          [ 'der max. Breite', 'width', ],
          [ 'der max. Höhe', 'height', ],
          [ 'der Position von links', 'left', ],
          [ 'der Position von oben', 'top', ],
        ],
      },
      {
        type: 'input_dummy',
      },
      {
        type: 'input_value',
        name: 'name',
        check: 'String',
      },
    ],
    colour: '#5b67a5',
  },
  {
    type: 'element_get_property_as_colour',
    message0: 'aktuelle %1 %2 von Element namens %3',
    output: 'Colour',
    args0: [
      {
        type: 'field_dropdown',
        name: 'property',
        options: [
          [ 'Text-Farbe', 'color', ],
          [ 'Hintergrund-Farbe', 'background-color', ],
          [ 'Rahmen-Farbe', 'border-color', ],
        ],
      },
      {
        type: 'input_dummy',
      },
      {
        type: 'input_value',
        name: 'name',
        check: 'String',
      },
    ],
    colour: '#a5745b',
  },
  {
    type: 'element_get_text',
    message0: 'aktueller Text von Element namens %1',
    output: 'String',
    args0: [
      {
        type: 'input_value',
        name: 'name',
        check: 'String',
      },
    ],
    colour: '#5ba58c',
  },
  {
    type: 'element_get_image',
    message0: 'aktuelles Bild von Element namens %1',
    output: 'Image',
    args0: [
      {
        type: 'input_value',
        name: 'name',
        check: 'String',
      },
    ],
    colour: '#99cc66',
  },
  {
    type: 'event_timeout',
    message0: 'In %1 Sekunden %2 mache %3 (und beim Warten mache jetzt sofort:)',
    args0: [
      {
        type: 'input_value',
        name: 'seconds',
        check: 'Number',
      },
      {
        type: 'input_dummy',
      },
      {
        type: 'input_statement',
        name: 'statements',
      },
    ],
    previousStatement: null,
    nextStatement: null,
    colour: '#00cccc',
  },
  {
    type: 'event_interval',
    message0: 'Alle %1 Sekunden %2 mache %3',
    args0: [
      {
        type: 'input_value',
        name: 'seconds',
        check: 'Number',
      },
      {
        type: 'input_dummy',
      },
      {
        type: 'input_statement',
        name: 'statements',
      },
    ],
    previousStatement: null,
    nextStatement: null,
    colour: '#00cccc',
  },
  {
    type: 'wait',
    message0: 'Warte %1 Sekunden',
    args0: [
      {
        type: 'input_value',
        name: 'seconds',
        check: 'Number',
      },
    ],
    previousStatement: null,
    nextStatement: null,
    colour: '#00cccc',
  },
]);

Blockly.Extensions.register('element_new_area_extension', function () {
  const block = this;
  
  this.onFieldShapeChanged = function (newValue) {
    if (newValue === 'image') {
      if (block.getInput('image') === null) {
        block.appendValueInput('image').setCheck('Image').appendField('mit Bild').setAlign(Blockly.ALIGN_RIGHT);
        block.moveInputBefore('methods');
      }
    } else {
      block.removeInput('image', true);
    }
  }
  
  this.getInput('name').appendField(
    new Blockly.FieldDropdown(
      [
        ['Rechteck', 'rectangle'],
        ['Quadrat', 'square'],
        ['Kreis', 'circle'],
        ['Bild', 'image'],
      ],
      function (newValue) {
        block.onFieldShapeChanged(newValue);
        return newValue;
      }
    ),
    'shape'
  ).appendField('namens');
  this.onFieldShapeChanged('');
});

Blockly.Extensions.register('element_method_change_property_extension', function () {
  const block = this;
  
  this.onFieldPropertyChanged = function (newValue) {
    if (newValue.includes('color')) {
      block.getInput('value').setCheck(['Colour', 'Transparent']);
    } else {
      block.getInput('value').setCheck('Number');
    }
  };
  
  this.getInput('value').appendField(
    new Blockly.FieldDropdown(
      [
        ['Text-Farbe', 'color'],
        ['Hintergrund-Farbe', 'background-color'],
        ['Rahmen-Farbe', 'border-color'],
        ['max. Breite (in %)', 'width'],
        ['max. Höhe (in %)', 'height'],
        ['Verhältnis Breite ÷ Höhe', 'aspect-ratio'],
        ['Position von links (in %)', 'left'],
        ['Position von oben (in %)', 'top'],
      ],
      function (newValue) {
        block.onFieldPropertyChanged(newValue);
        return newValue;
      }
    ),
    'property'
  ).appendField('der Fläche auf');
  this.onFieldPropertyChanged('');
});

Blockly.Extensions.register('element_method_move_area_extension', function () {
  const block = this;
  
  this.onFieldTargetChanged = function (newValue) {
    if (newValue.endsWith('-area')) {
      if (block.getInput('name') === null) {
        block.appendValueInput('name').setCheck('String').setAlign(Blockly.ALIGN_RIGHT);
        block.getInput('name').appendField('der Fläche namens', 'name-label');
      }
    } else {
      block.removeInput('name', true);
    }
  }
  
  this.getInput('container').appendField(
    new Blockly.FieldDropdown(
      [
        ['an das Ende', 'end'],
        ['an den Anfang', 'begin'],
        ['als letzte Teilfläche von', 'last-in-area'],
        ['als erste Teilfläche von', 'first-in-area'],
        ['als Nachfolger von', 'after-area'],
        ['als Vorgänger von', 'before-area'],
      ],
      function (newValue) {
        block.onFieldTargetChanged(newValue);
        return newValue;
      }
    ),
    'target'
  ).setAlign(Blockly.ALIGN_RIGHT);
  this.onFieldTargetChanged('');
});

Blockly.Extensions.register('event_key_extension', function () {
  const block = this;
  
  this.onFieldKeyChanged = function (newValue) {
    if (newValue === 'Other') {
      if (block.getInput('text') === null) {
        block.appendValueInput('text').setCheck('String').appendField('mit Text').setAlign(Blockly.ALIGN_RIGHT);
      }
    } else {
      block.removeInput('text', true);
    }
    block.moveInputBefore('statements');
  }
  
  this.getInput('container').appendField(
    new Blockly.FieldDropdown(
      [
        ['Taste', 'Other'],
        ['←', 'ArrowLeft'],
        ['→', 'ArrowRight'],
        ['↑', 'ArrowUp'],
        ['↓', 'ArrowDown'],
        ['Bild ↑', 'PageUp'],
        ['Bild ↓', 'PageDown'],
        ['Pos 1', 'Home'],
        ['Ende', 'End']
      ],
      function (newValue) {
        block.onFieldKeyChanged(newValue);
        return newValue;
      }
    ),
    'key'
  );
  this.onFieldKeyChanged('');
});

class FieldImage extends Blockly.FieldDropdown {
  constructor(topic) {
    const images = [];

    openmojiTopics[topic].forEach((data, hexcode) => {
      images.push([
        {src: 'node_modules/openmoji/color/svg/' + hexcode + '.svg', width: 40, height: 40, alt: data.annotation},
        hexcode,
      ]);
    });
    super(images);

    this.topic = topic;
  }

  showEditor_() {
    openModal(() => {
      newArea('square', 'grid')
        .setProperty('height', 100)
        .setProperty('left', 50)
        .setProperty('top', 50)
        .setProperty('border-color', 'transparent');
      
      let size = Math.ceil(Math.sqrt(openmojiTopics[this.topic].size));
      let column = 0;
      let row = 0;

      openmojiTopics[this.topic].forEach((data, hexcode) => {
        let imageUrl = 'url(node_modules/openmoji/color/svg/' + hexcode + '.svg)';

        newArea('square')
          .setProperty('width', 100 / size)
          .setProperty('height', 100 / size)
          .setProperty('left', 100 * column / (size - 1))
          .setProperty('top', 100 * row / (size - 1))
          .setProperty('image', imageUrl)
          .setProperty('border-color', 'transparent')
          .moveToEnd(findElements('grid'))
          .onClick(() => {
            this.setValue(hexcode);
            closeModal();
          });

        column++;
        if (column === size) {
          row++;
          column = 0;
        }
      });
    });
  }
}

Blockly.Extensions.register('image_extension', function () {
  this.getInput('container').appendField(
    new FieldImage(this.type.replace(/^image_/, '')),
    'image'
  );
});
