const openmojiNames = new Map();

const openmojiVariants = new Map();

const openmojiTopics = {
  animal: new Map(),
  plant: new Map(),
  face: new Map(),
  food: new Map(),
  sports: new Map(),
  person: new Map(),
  body: new Map(),
  family: new Map(),
  transport: new Map(),
  place: new Map(),
  sky: new Map(),
  time: new Map(),
  music: new Map(),
  clothing: new Map(),
  game: new Map(),
  writing: new Map(),
  computer: new Map(),
  objects: new Map(),
  symbol: new Map(),
};

openmojiData.forEach((data) => {
  openmojiNames.set(data.hexcode, data.annotation);

  if (data.skintone_base_hexcode === '' || data.skintone_base_hexcode === data.hexcode) {

    if (data.subgroups.includes('animal') || data.subgroups.includes('cat-') || data.subgroups.includes('monkey-') || data.openmoji_tags.includes('animal')) {
      openmojiTopics.animal.set(data.hexcode, data);
    } else if (data.subgroups.includes('plant')) {
      openmojiTopics.plant.set(data.hexcode, data);
    } else if (data.subgroups.includes('face') || data.subgroups.includes('smileys')) {
      openmojiTopics.face.set(data.hexcode, data);
    } else if (data.subgroups.includes('body-parts') || data.subgroups.includes('hand')) {
      openmojiTopics.body.set(data.hexcode, data);
    }
    
    if (data.group.includes('food') || data.subgroups.includes('food')) {
      openmojiTopics.food.set(data.hexcode, data);
    }
    
    if (data.subgroups.includes('transport') || data.annotation.includes('boat') || data.tags.includes('bicycle')) {
      openmojiTopics.transport.set(data.hexcode, data);
    }
    
    if (data.subgroups.includes('place')) {
      openmojiTopics.place.set(data.hexcode, data);
    }
    
    if (data.subgroups.includes('family')) {
      openmojiTopics.family.set(data.hexcode, data);
    }
    
    if (data.subgroups.includes('weather') || data.subgroups.includes('-air')) {
      openmojiTopics.sky.set(data.hexcode, data);
    }
    
    if (data.subgroups.includes('time')) {
      openmojiTopics.time.set(data.hexcode, data);
    }
    
    if (data.subgroups.includes('medal') || data.subgroups === 'sport' || data.openmoji_tags.includes('sports')) {
      openmojiTopics.sports.set(data.hexcode, data);
    } else if (data.subgroups.includes('music')) {
      openmojiTopics.music.set(data.hexcode, data);
    } else if (data.subgroups.includes('clothing')) {
      openmojiTopics.clothing.set(data.hexcode, data);
    } else if (data.subgroups.includes('game')) {
      openmojiTopics.game.set(data.hexcode, data);
    } else if (data.subgroups === 'mail' || data.subgroups === 'writing' || data.subgroups === 'book-paper') {
      openmojiTopics.writing.set(data.hexcode, data);
    } else if (data.subgroups === 'computer') {
      openmojiTopics.computer.set(data.hexcode, data);
    } else if (data.group.includes('objects') || data.subgroups.includes('objects') || data.subgroups.includes('crafts') || data.subgroups.includes('hotel') || data.subgroups.includes('gardening') && !data.annotation.includes('gardener')) {
      openmojiTopics.objects.set(data.hexcode, data);
    } else if (data.subgroups.includes('person') || data.subgroups.includes('people') || data.annotation.includes('gardener')) {
      openmojiTopics.person.set(data.hexcode, data);
    } else if (data.subgroups === 'arrow' || data.subgroups === 'geometric' || data.subgroups === 'religion' || data.subgroups === 'event' || data.subgroups === 'emotion' || data.subgroups === 'warning' || data.subgroups === 'symbol-other') {
      openmojiTopics.symbol.set(data.hexcode, data);
    }

  } else {
    const variants = openmojiVariants.get(data.skintone_base_hexcode) || [];
    variants.push(data.hexcode);
  }
});
