const toolbox = {
  kind: 'categoryToolbox',
  contents: [
    {
      kind: 'category',
      name: 'Text',
      contents: [
        {
          kind: 'block',
          type: 'text',
        },
        {
          kind: 'block',
          type: 'text_multiline',
        },
        {
          kind: 'block',
          type: 'text_print',
          inputs: {
            'TEXT': {shadow: {type: 'text', fields: {'TEXT': 'Hallo!'}}},
          },
        },
        {
          kind: 'block',
          type: 'text_prompt',
          extraState: '<mutation type="TEXT"></mutation>',
          fields: {'TEXT': 'Welcher Text?'},
        },
        {
          kind: 'block',
          type: 'text_join'
        },
        {
          kind: 'block',
          type: 'element_get_text',
        },
        {
          kind: 'block',
          type: 'event_key',
        },
      ],
      colour: '#5ba58c'
    },
    {
      kind: 'category',
      name: 'Zahlen',
      contents: [
        {
          kind: 'block',
          type: 'math_number',
          fields: {'NUM': 100},
        },
        {
          kind: 'block',
          type: 'math_arithmetic',
          fields: {'OP': 'DIVIDE'},
          inputs: {
            'A': {shadow: {type: 'math_number', fields: {'NUM': 10}}},
            'B': {shadow: {type: 'math_number', fields: {'NUM': 3}}},
          },
        },
        {
          kind: 'block',
          type: 'math_modulo',
          inputs: {
            'DIVIDEND': {shadow: {type: 'math_number', fields: {'NUM': 10}}},
            'DIVISOR': {shadow: {type: 'math_number', fields: {'NUM': 3}}},
          },
        },
        {
          kind: 'block',
          type: 'math_round',
          fields: {'OP': 'ROUND'},
          inputs: {
            'NUM': {shadow: {type: 'math_number', fields: {'NUM': 1.5}}},
          },
        },
        {
          kind: 'block',
          type: 'math_random_float'
        },
        {
          kind: 'block',
          type: 'math_on_list',
        },
        {
          kind: 'block',
          type: 'element_get_property_as_number',
        },
        {
          kind: 'block',
          type: 'controls_repeat_ext',
        },
        {
          kind: 'block',
          type: 'wait',
          inputs: {
            'seconds': {shadow: {type: 'math_number', fields: {'NUM': 1.5}}},
          },
        },
        {
          kind: 'block',
          type: 'event_interval',
          inputs: {
            'seconds': {shadow: {type: 'math_number', fields: {'NUM': 0.5}}},
          },
        },
        {
          kind: 'block',
          type: 'event_timeout',
          inputs: {
            'seconds': {shadow: {type: 'math_number', fields: {'NUM': 0.1}}},
          },
        },
      ],
      colour: '#5b67a5',
    },
    {
      kind: 'category',
      name: 'wahr/falsch',
      contents: [
        {
          kind: 'block',
          type: 'controls_if'
        },
        {
          kind: 'block',
          type: 'controls_whileUntil',
        },
        {
          kind: 'block',
          type: 'logic_compare',
          fields: {'OP': 'EQ'},
          inputs: {
            'A': {shadow: {type: 'math_number', fields: {'NUM': 1}}},
            'B': {shadow: {type: 'math_number', fields: {'NUM': 1}}},
          },
        },
        {
          kind: 'block',
          type: 'logic_operation',
          fields: {'OP': 'OR'},
        },
        {
          kind: 'block',
          type: 'logic_negate'
        },
        {
          kind: 'block',
          type: 'logic_boolean'
        },
        {
          kind: 'block',
          type: 'math_number_property',
          fields: {'PROPERTY': 'EVEN'},
          inputs: {
            'NUMBER_TO_CHECK': {shadow: {type: 'math_number', fields: {'NUM': 0}}},
          },
        }
      ],
      colour: '#5b80a5'
    },
    {
      kind: 'category',
      name: 'Elemente',
      contents: [
        {
          kind: 'block',
          type: 'element_new_area',
          fields: {'shape': 'rectangle'},
        },
        {
          kind: 'block',
          type: 'element_find'
        },
        {
          kind: 'block',
          type: 'element_new_button',
        },
        {
          kind: 'block',
          type: 'element_method_change_text'
        },
        {
          kind: 'block',
          type: 'element_method_change_image'
        },
        {
          kind: 'block',
          type: 'element_method_change_property',
        },
        {
          kind: 'block',
          type: 'element_method_move_area'
        },
        {
          kind: 'block',
          type: 'element_method_delete'
        },
        {
          kind: 'block',
          type: 'element_method_event_click'
        },
      ],
      colour: '#990000'
    },
    {
      kind: 'category',
      name: 'Farben',
      contents: [
        {
          kind: 'block',
          type: 'colour_picker'
        },
        {
          kind: 'block',
          type: 'colour_transparent'
        },
        {
          kind: 'block',
          type: 'colour_random',
        },
        {
          kind: 'block',
          type: 'colour_rgb',
          inputs: {
            'RED': {shadow: {type: 'math_number', fields: {'NUM': 100}}},
            'GREEN': {shadow: {type: 'math_number', fields: {'NUM': 50}}},
            'BLUE': {shadow: {type: 'math_number', fields: {'NUM': 0}}},
          },
        },
        {
          kind: 'block',
          type: 'colour_blend',
          inputs: {
            'COLOUR1': {shadow: {type: 'colour_picker', fields: {'COLOUR': '#ff0000'}}},
            'COLOUR2': {shadow: {type: 'colour_picker', fields: {'COLOUR': '#0000ff'}}},
            'RATIO': {shadow: {type: 'math_number', fields: {'NUM': 0.5}}},
          },
        },
        {
          kind: 'block',
          type: 'element_get_property_as_colour',
        }
      ],
      colour: '#a5745b',
    },
    {
      kind: 'category',
      name: 'Bilder',
      contents: [
        {
          kind: 'block',
          type: 'element_get_image',
        },
        {
          kind: 'block',
          type: 'image_animal',
          fields: {image: '1F98A'},
        },
        {
          kind: 'block',
          type: 'image_plant',
          fields: {image: '1F3F5'},
        },
        {
          kind: 'block',
          type: 'image_person',
          fields: {image: '1F467'},
        },
        {
          kind: 'block',
          type: 'image_face',
          fields: {image: '1F60E'},
        },
        {
          kind: 'block',
          type: 'image_body',
          fields: {image: '1F44B'},
        },
        {
          kind: 'block',
          type: 'image_family',
          fields: {image: '1F468-200D-1F467'},
        },
        {
          kind: 'block',
          type: 'image_sports',
          fields: {image: '26F9'},
        },
        {
          kind: 'block',
          type: 'image_game',
          fields: {image: '1F3B2'},
        },
        {
          kind: 'block',
          type: 'image_food',
          fields: {image: '1F347'},
        },
        {
          kind: 'block',
          type: 'image_place',
          fields: {image: '1F3E0'},
        },
        {
          kind: 'block',
          type: 'image_computer',
          fields: {image: '1F5A5'},
        },
        {
          kind: 'block',
          type: 'image_writing',
          fields: {image: '2712'},
        },
        {
          kind: 'block',
          type: 'image_transport',
          fields: {image: '1F69F'},
        },
        {
          kind: 'block',
          type: 'image_sky',
          fields: {image: '1F324'},
        },
        {
          kind: 'block',
          type: 'image_time',
          fields: {image: '1F554'},
        },
        {
          kind: 'block',
          type: 'image_music',
          fields: {image: '1F3B6'},
        },
        {
          kind: 'block',
          type: 'image_clothing',
          fields: {image: '1F45A'},
        },
        {
          kind: 'block',
          type: 'image_objects',
          fields: {image: '1F4D0'},
        },
        {
          kind: 'block',
          type: 'image_symbol',
          fields: {image: '262E'},
        },
      ],
      colour: '#99cc66',
    },
    {
      kind: 'category',
      name: 'Liste',
      contents: [
        {
          kind: 'block',
          type: 'lists_create_with'
        },
        {
          kind: 'block',
          type: 'controls_forEach'
        }
      ],
      colour: '#745ba5'
    },
    {
      kind: 'category',
      name: 'Variablen',
      custom: 'VARIABLE',
      colour: '#a55b80',
    },
    {
      kind: 'category',
      name: 'Prozeduren',
      custom: 'PROCEDURE',
      colour: '#995ba5'
    }
  ]
};
